stages:
  - build
  - release
image: "rust:1.69-bullseye"

variables:
  DOCKER_DRIVER: overlay2
  VERSION: "1.0.0"
  RUST_VERSION: "1.69"
  JITO_VERSION: "v1.18.21-jito"

build:
  only:
    - main
  stage: build
  tags:
    - xlarge
    - kubernetes
    - mgmt-nonprod
  before_script:
    - rustc --version && cargo --version
    - apt-get update -yqq
    - apt-get install -y libssl-dev libudev-dev pkg-config zlib1g-dev llvm clang cmake make libprotobuf-dev protobuf-compiler > /dev/null
    - git config --global user.email "chuck@blockdaemon.com"
    - git config --global user.name "Chuck"
    - echo "test"
    - git clone https://github.com/jito-foundation/jito-solana.git --recurse-submodules > /dev/null
    - cd jito-solana
    - git fetch --all
    - git checkout -b v1.18_patched v1.18.21-jito  > /dev/null
    - git submodule update -i -r
    - git clone https://github.com/solana-labs/rbpf.git --depth 1 --branch v0.8.0
    - cd rbpf
    - git am ../../0001-Apply-rbpf-patch.patch
    - cd ..
    - git am ../0001-Update-dependency.patch
    - rustup install $RUST_VERSION
    - rustup default $RUST_VERSION
    - rustup component add rustfmt
  script:
    - CI_COMMIT=$(git rev-parse HEAD) scripts/cargo-install-all.sh --validator-only /builds/Blockdaemon/solana/solana-jito-validator-builder/releases/"$JITO_VERSION"
  after_script:
    - echo "JOB_ID=$CI_JOB_ID" >> job.env
  artifacts:
    paths:
      - /builds/Blockdaemon/solana/solana-jito-validator-builder/releases/$JITO_VERSION/bin
    expire_in: never
    reports:
      dotenv: job.env

create:release:
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  needs:
    - job: build
      artifacts: true
  variables:
    TAG: '$CI_COMMIT_SHA'
  script:
    - echo "Create Release $JITO_VERSION"
    - echo $JOB_ID
  only:
    - main
  release:
    name: 'Release $JITO_VERSION'
    tag_name: '$JITO_VERSION'
    ref: '$TAG'
    description: 'Release $JITO_VERSION'
    assets:
      links:
        - name: "release-$JITO_VERSION.zip"
          url: "https://gitlab.com/Blockdaemon/solana/solana-jito-validator-builder/-/jobs/$JOB_ID/artifacts/download"
